'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _hyperquest = require('hyperquest');

var _hyperquest2 = _interopRequireDefault(_hyperquest);

var _stream = require('stream');

var _url = require('url');

var _db = require('./db');

var _db2 = _interopRequireDefault(_db);

var protocolTestPattern = /^https?:$/;

var request = function request(etcddb, url_suffix, query_parameters) {};

var EtcdJobDB = (function (_JobDB) {
  _inherits(EtcdJobDB, _JobDB);

  function EtcdJobDB(_ref) {
    var url = _ref.url;

    _classCallCheck(this, EtcdJobDB);

    _get(Object.getPrototypeOf(EtcdJobDB.prototype), 'constructor', this).call(this);
    var urlParts = (0, _url.parse)(url, true);
    if (protocolTestPattern.test(urlParts.protocol) == false) {
      throw new Error('unknown protocol ' + urlParts.protocol);
    }
    if (!urlParts.query) {
      urlParts.query = {};
    }
    if (urlParts.pathname.slice(-1) != '/') {
      urlParts.pathname += '/';
    }
    this.url = (0, _url.format)(urlParts);
  }

  _createClass(EtcdJobDB, [{
    key: 'atomicSwap',
    value: function atomicSwap(key, value, version) {
      notImplemented("swap");
    }
  }, {
    key: 'delete',
    value: function _delete(key, version, cb) {
      var newParts = (0, _url.parse)(this.url);
      newParts.pathname += '' + encodeURI(key);
      newParts.query.prevIndex = version;
      (0, _hyperquest2['default'])({
        uri: (0, _url.format)(newParts),
        method: 'DELETE'
      }, function (err, res) {
        if (err) cb(err);else if (res.statusCode != 200) {
          var statusErr = new Error('Got HTTP Status Code: ' + res.statusCode);
          res.pipe(process.stderr);
          cb(statusErr);
        } else cb(null);
      });
    }
  }, {
    key: 'get',
    value: function get(key, cb) {
      var newParts = (0, _url.parse)(this.url);
      newParts.pathname += '' + encodeURI(key);
      (0, _hyperquest2['default'])({
        uri: (0, _url.format)(newParts),
        method: 'GET'
      }, function (err, res) {
        if (err) cb(err, null);else if (res.statusCode != 200) {
          var statusErr = new Error('Got HTTP Status Code: ' + res.statusCode);
          cb(statusErr, null);
        } else {
          var pipe = new _stream.PassThrough();
          res.pipe(pipe);
          cb(null, pipe);
        }
      });
    }
  }, {
    key: 'insert',
    value: function insert(key, value) {
      var _ref2 = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

      var ttl = _ref2.ttl;

      var newParts = (0, _url.parse)(this.url);
      newParts.pathname += '' + encodeURI(key);
      newParts.query.prevExists = 'false';
      (0, _hyperquest2['default'])({
        uri: newParts,
        method: 'PUT'
      }, function (err, res) {
        if (err) cb(err);else if (res.statusCode != 201) {
          var statusErr = new Error('Got HTTP Status Code: ' + res.statusCode);
          cb(statusErr);
        } else cb(null);
      });
    }
  }, {
    key: 'update',
    value: function update(key, value) {
      var _ref3 = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

      var ttl = _ref3.ttl;

      notImplemented("update");
    }
  }, {
    key: 'upsert',
    value: function upsert(key, value) {
      var _ref4 = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

      var ttl = _ref4.ttl;

      notImplemented("upsert");
    }
  }, {
    key: 'watch',
    value: function watch(namespace, observer) {
      notImplemented("watch");
    }
  }]);

  return EtcdJobDB;
})(_db2['default']);

exports['default'] = EtcdJobDB;
module.exports = exports['default'];
//# sourceMappingURL=etcddb.js.map